*! by Hung-Jen Wang
*!   based on  -integrate-

*! usage:
*!
*!  scalar aa = 0.5
*!  scalar bb = 0.4
*!  scalar bb1 = -0.1
*!  scalar cc = 0.2
*!  scalar dd = -0.2
*!  scalar ee = 0.2
*!  scalar ff = 0.2
*!  scalar gg = 0.2
*!  scalar hh = 0.2
*!  scalar ii = -0.1
*!  scalar jj = 0.1
*!
*! myint5a, alphadd(aa) alphaz(bb) xalphax(bb1) rho(cc) mylow(dd) myup(ee) sigma1(ff) sigma2(gg) prob(hh) m1(ii) m2(jj) saveas(my_res)
*!  It will save the integrated result in the scalar my_res.

capture program drop myint5a
program define myint5a

version 12

  syntax , alphadd(namelist) alphaz(namelist) xalphax(namelist) rho(namelist) mylow(namelist) myup(namelist) sigma1(namelist) sigma2(namelist) prob(namelist) m1(namelist) m2(namelist) saveas(namelist)

  mata: alphaddc = st_numscalar("`alphadd'")
  mata: alphazc = st_numscalar("`alphaz'")
  mata: xalphax = st_numscalar("`xalphax'")
  mata: rhoc    = st_numscalar("`rho'")
  mata: mylow   = st_numscalar("`mylow'")
  mata: myup    = st_numscalar("`myup'")
  mata: sigma1c = st_numscalar("`sigma1'")
  mata: sigma2c = st_numscalar("`sigma2'")
  mata: probc   = st_numscalar("`prob'")
  mata: m1c     = st_numscalar("`m1'")
  mata: m2c     = st_numscalar("`m2'")

  mata: st_numscalar("`saveas'", evalC( alphaddc, alphazc, xalphax, rhoc, mylow, myup, sigma1c, sigma2c, probc, m1c, m2c))

  display as txt "The result is " as res `saveas' as txt " which is saved in the scalar " as res "`saveas'" as txt "."

end


mata:

real rowvector myfun1(real rowvector x, real rowvector arg)
{
   alphaddC = arg[1]
   alphazC = arg[2]
   xalphaxC = arg[3]
   rhoC = arg[4]
   sigma1C = arg[5]
   sigma2C = arg[6]
   probC = arg[7]
   m1C = arg[8]
   m2C = arg[9]
   y = arg[10]

   return((normal(( alphaddC :+ alphazC :* y :+ xalphaxC :+ rhoC :* x) :/ (sqrt(1-(rhoC):^2))) :* normalden(x) :* (probC :* normalden(y, m1C, sigma1C) :+ (1-probC) :* normalden(y, m2C, sigma2C))  ))

}
real rowvector myinner(real rowvector y, real rowvector arg)
{
   alphaddC = arg[1]
   alphazC = arg[2]
   xalphaxC = arg[3]
   rhoC = arg[4]
   mylowC = arg[5]
   myupC  = arg[6]
   sigma1C = arg[7]
   sigma2C = arg[8]
   probC = arg[9]
   m1C = arg[10]
   m2C = arg[11]

    c  = (alphaddC, alphazC, xalphaxC, rhoC, sigma1C, sigma2C, probC, m1C, m2C)

     for(i=1; i<=cols(y);i++) {
        if (i==1) f=integrate(&myfun1(), mylowC, myupC, 60, (c, y[i]))
        else f = f, integrate(&myfun1(), mylowC, myupC, 60, (c, y[i]))
     }
     return(f)
}



real scalar evalC( real scalar alphaddC, real scalar alphazC, real scalar xalphaxC, real scalar rhoC, real scalar mylow, real scalar myup, real scalar sigma1C, real scalar sigma2C, real scalar probC, real scalar m1C, real scalar m2C)
{
   c  = (alphaddC, alphazC, xalphaxC, rhoC, mylow, myup, sigma1C, sigma2C, probC, m1C, m2C)
   return( integrate(&myinner(), ., ., 60, c))
}

end
